package cz.sa.shiftPlanner.auth;

import org.springframework.stereotype.Service;

import cz.sa.shiftPlanner.enums.UserRoleHierarchy;

@Service
public class UserRoleCollection {

  /**
   * 
   * @param role
   * @return UserRoleHierarchy lexikograph equals input param NOTE : java 6 does
   *         not support string param in switch
   */
  private UserRoleHierarchy getRole(String role) {
    if (role == null)
      throw new IllegalArgumentException("role is null");
    Role r = Role.valueOf(role.toLowerCase());
    switch (r) {
      case steward:
        return UserRoleHierarchy.Steward;
      case coordinator:
        return UserRoleHierarchy.Coordinator;
      case supervisor:
        return UserRoleHierarchy.Supervisor;
      default:
        return UserRoleHierarchy.Helplinka;
    }
  }

  private enum Role {
    steward, helplinka, coordinator, supervisor;
  }

  public boolean checkRoleHierarchy(String userRole, String objectRole) {
    UserRoleHierarchy eUserRole = getRole(userRole.toLowerCase());
    UserRoleHierarchy eObjectRole = getRole(objectRole.toLowerCase());
    if (eUserRole.is(eObjectRole))
      return true;
    else
      return false;
  }
}
