package cz.sa.shiftPlanner.dao;

import java.util.List;

import org.joda.time.DateTime;

import cz.sa.shiftPlanner.dto.PersonRecordDTO;
import cz.sa.shiftPlanner.entities.ExcuseVO;
import cz.sa.shiftPlanner.entities.PersonRecordVO;
import cz.sa.shiftPlanner.entities.PersonVO;
import cz.sa.shiftPlanner.entities.TimeTrialVO;
import cz.sa.shiftPlanner.entities.WorkHoursItemVO;
import cz.sa.shiftPlanner.entities.WorkHoursVO;
import cz.sa.shiftPlanner.enums.ExcuseReason;
import cz.sa.shiftPlanner.utils.TimeRange;

/**
 * @author ToSk
 */

public interface PersonUtilsDAO {

	void createExcuse(ExcuseVO excuse);
	
	List<ExcuseVO> findAll();
	
	List<ExcuseVO> findAllByPersonId(Long id);
	
	void createWorkHours(WorkHoursVO hours);
	
	WorkHoursVO findHourByIdAndMonth(Long personId, int month, int year);
	
	/**
	 * also update workHours monthAmount column
	 */
	void createWorkHoursItem(WorkHoursItemVO hours);
	
	/**
	 * also update workHours monthAmount column
	 */
	void updateWorkHoursItem(WorkHoursItemVO hours);
	
	WorkHoursItemVO findItemByIdAndDay(Long HoursId, int day);
	
	Long sumMonthHours(Long HoursId);
	
	List<TimeRange> rangesInDay(DateTime dt, PersonVO p);

	void remove(ExcuseVO map);

	void update(ExcuseVO map);

	WorkHoursVO getHours(WorkHoursVO hours);

	void updateWorkHours(WorkHoursVO hours);

	List<TimeTrialVO> findAllByPersonId(long personId, DateTime from, DateTime to);

	void create(TimeTrialVO tt);

	void update(TimeTrialVO tt);

	void remove(TimeTrialVO tt);

	List<TimeTrialVO> findAllByDay(DateTime day);

  List<ExcuseVO> excusesInDay(DateTime dt, ExcuseReason reason);

  void createRecord(PersonRecordVO rec);

  List<PersonRecordVO> findRecordByPerson(PersonVO map);

  void removeRecord(PersonRecordVO rec);
}


