package cz.sa.shiftPlanner.daoImpl;

import java.util.List;

import jxl.common.Logger;

import org.springframework.stereotype.Repository;

import cz.sa.shiftPlanner.dao.LineGroupDAO;
import cz.sa.shiftPlanner.entities.LineGroupVO;
import cz.sa.shiftPlanner.entities.LineVO;
import cz.sa.shiftPlanner.infrastructure.dao.AbstractDao;

@Repository
public class LineGroupDAOImpl extends AbstractDao implements LineGroupDAO {

  private static final Logger log = Logger.getLogger(LineGroupDAOImpl.class);
  
  @Override
  public LineGroupVO get(Long id) {
    if (id == null)
      throw new IllegalArgumentException("lineGroup");
    return (LineGroupVO) getSession().get(LineGroupVO.class, id);
  }

  @Override
  public void update(LineGroupVO line) {
    if (line == null)
      throw new IllegalArgumentException("lineGroup");
    if (line.getId() == null)
      throw new IllegalArgumentException("not perzisted");

    getSession().merge(line);
  }

  @Override
  public void remove(LineGroupVO line) {
    if (line == null)
      throw new IllegalArgumentException("lineGroup");
    if (line.getId() == null)
      throw new IllegalArgumentException("not perzisted");

    getSession().delete(line);

  }

  @Override
  public List<LineGroupVO> findAll() {
    return getSession().createQuery("from LineGroupVO as l order by l.name").list();
  }

  @Override
  public void save(LineGroupVO line) {
    if (line == null)
      throw new IllegalArgumentException("lineGroup");
    getSession().save(line);
  }

  @Override
  public LineVO getLine(Long id) {
    if (id == null)
      throw new IllegalArgumentException("line");
    return (LineVO) getSession().get(LineVO.class, id);
  }

  @Override
  public void saveLine(LineVO line) {
    if (line == null)
      throw new IllegalArgumentException("line");
    getSession().save(line);
    log.info("LineVO was created.");
  }

}
