package cz.sa.shiftPlanner.daoImpl;

import java.util.List;

import org.springframework.stereotype.Repository;

import cz.sa.shiftPlanner.dao.UserDAO;
import cz.sa.shiftPlanner.entities.PersonVO;
import cz.sa.shiftPlanner.entities.infrastructure.UserVO;
import cz.sa.shiftPlanner.infrastructure.dao.AbstractDao;

@Repository
public class UserDAOImpl extends AbstractDao implements UserDAO {

	@Override
	public UserVO get(String username) {
		if(username == null) throw new IllegalArgumentException("user");
		return (UserVO) getSession().createQuery("Select u from UserVO as u where u.username = :username")
		    .setParameter("username", username).uniqueResult();
	}

	@Override
	public UserVO get(Long id) {

		return (UserVO)getSession().get(UserVO.class, id);
	}

	@Override
	public void create(UserVO user) {

		if(user.getId() == null){
			getSession().save(user);
		}
	}

	@Override
	public void remove(UserVO user) {

		if(user.getId() != null){
			getSession().delete(user);
		}
	}

	@Override
	public void update(UserVO user) {

		if(user.getId() != null){
			getSession().merge(user);
		}
	}

	@Override
	public List<UserVO> findAll() {
		return getSession().createCriteria(UserVO.class).list();
	}

	@Override
	public UserVO findByPerson(PersonVO p) {
		
		if(p == null) throw new IllegalArgumentException("user");
		return (UserVO) getSession().createQuery("Select u from UserVO as u where u.person.id = :id").setParameter("id", p.getId()).uniqueResult();
	}

	@Override
	public List<UserVO> findSignIn() {
		
		return getSession().createQuery("select u from UserVO as u where u.isSign is true").list();
	}

	

}
