package cz.sa.shiftPlanner.entities;

import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;

import org.hibernate.annotations.Type;
import org.joda.time.DateTime;

import cz.sa.shiftPlanner.entities.infrastructure.AbstractVO;
import cz.sa.shiftPlanner.enums.WeekDay;

@Entity
@Table(name="bus_turns_timetable")
public class BusTurnsTimetableVO extends AbstractVO {

	@ManyToOne(fetch = FetchType.LAZY)
	private BusTimetableVO timetable;
	
	@Column(nullable=true)
	private Integer coupleNumber;

	@Column
	@Enumerated(EnumType.STRING)
	private WeekDay weekDay;
	
	@OneToMany( mappedBy = "turn", fetch = FetchType.LAZY)
	private Set<RuleVO> rules;
	
	@Type(type = "org.jadira.usertype.dateandtime.joda.PersistentDateTime")
	private DateTime validity_from;

	@Type(type = "org.jadira.usertype.dateandtime.joda.PersistentDateTime")
	private DateTime validity_to;
	
	@Column
	private String noteBefore;
	
	@Column
	private String noteAfter;
	
	@Column(nullable=true)
	private Integer week;
	
	
	public Integer getWeek() {
		return week;
	}

	public void setWeek(Integer week) {
		this.week = week;
	}

	public String getNoteBefore() {
		return noteBefore;
	}

	public void setNoteBefore(String noteBefore) {
		this.noteBefore = noteBefore;
	}

	public String getNoteAfter() {
		return noteAfter;
	}

	public void setNoteAfter(String noteAfter) {
		this.noteAfter = noteAfter;
	}

	public DateTime getValidity_from() {
		return validity_from;
	}

	public void setValidity_from(DateTime validity_from) {
		this.validity_from = validity_from;
	}

	public DateTime getValidity_to() {
		return validity_to;
	}

	public void setValidity_to(DateTime validity_to) {
		this.validity_to = validity_to;
	}

	public BusTimetableVO getTimetable() {
		return timetable;
	}

	public void setTimetable(BusTimetableVO timetable) {
		this.timetable = timetable;
	}

	public Integer getCoupleNumber() {
		return coupleNumber;
	}

	public void setCoupleNumber(Integer coupleNumber) {
		this.coupleNumber = coupleNumber;
	}

	public WeekDay getWeekDay() {
		return weekDay;
	}

	public void setWeekDay(WeekDay weekDay) {
		this.weekDay = weekDay;
	}

	

	public Set<RuleVO> getRules() {
		return rules;
	}

	public void setRules(Set<RuleVO> rules) {
		this.rules = rules;
	}

	@Override
	public String toString() {
		return "BusTurnsTimetableVO [timetable=" + timetable
				+ ", coupleNumber=" + coupleNumber + "]";
	}


}
