package cz.sa.shiftPlanner.entities;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

import org.hibernate.annotations.Type;
import org.joda.time.DateTime;

import cz.sa.shiftPlanner.entities.infrastructure.AbstractNoGenVO;
import cz.sa.shiftPlanner.entities.infrastructure.AbstractVO;

@Entity
@Table(name = "line_group")
public class LineGroupVO extends AbstractNoGenVO{
	
	@Column(columnDefinition="varchar(50)", nullable=false)
	private String name;
	
	@Column(columnDefinition="varchar(50)")
	private String code;
	
	@Column(columnDefinition="varchar(50)")
	private String superIntendant;
	
	@Column
	private boolean isInterstate;
	
	@Type(type = "org.jadira.usertype.dateandtime.joda.PersistentDateTime")
	@Column(nullable = true)
	private DateTime dateUpdated;

	
	public DateTime getDateUpdated() {
    return dateUpdated;
  }

  public void setDateUpdated(DateTime dateUpdated) {
    this.dateUpdated = dateUpdated;
  }

  public boolean isInterstate() {
		return isInterstate;
	}

	public void setInterstate(boolean isInterstate) {
		this.isInterstate = isInterstate;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getCode() {
		return code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	public String getSuperIntendant() {
		return superIntendant;
	}

	public void setSuperIntendant(String superIntendant) {
		this.superIntendant = superIntendant;
	}

	@Override
	public String toString() {
		return "name=" + name + ",Id=" + getId();
	}

	

}
