package cz.sa.shiftPlanner.entities;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Embedded;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.PrimaryKeyJoinColumn;
import javax.persistence.Table;

import cz.sa.shiftPlanner.entities.infrastructure.AbstractVO;
import cz.sa.shiftPlanner.enums.ExcuseReason;
import cz.sa.shiftPlanner.enums.MeasurementType;
import cz.sa.shiftPlanner.utils.Quantity;

/**
 *
 * @author    ToSk
 * @version   1.0
 * @created   15. 10. 2013
 */

@Entity
@Table(name = "person_record")
public class PersonRecordVO extends AbstractVO {

  @ManyToOne(cascade = CascadeType.DETACH)
  @JoinColumn(name="createdby_id")
  private PersonVO createdBy;
  
  @Column(nullable = true)
  private String description;
  
  @Column(name="type") 
  @Enumerated(EnumType.STRING)
  private MeasurementType type;
  
  @Embedded
  private Quantity quantity;
  
  @ManyToOne(fetch = FetchType.LAZY)
  private PersonVO person;
  

  public PersonVO getPerson() {
    return person;
  }

  public void setPerson(PersonVO person) {
    this.person = person;
  }

  public PersonVO getCreatedBy() {
    return createdBy;
  }

  public void setCreatedBy(PersonVO createdBy) {
    this.createdBy = createdBy;
  }

  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public MeasurementType getType() {
    return type;
  }

  public void setType(MeasurementType type) {
    this.type = type;
  }

  public Quantity getQuantity() {
    return quantity;
  }

  public void setQuantity(Quantity quantity) {
    this.quantity = quantity;
  }
  
  
}
