package cz.sa.shiftPlanner.entities;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.annotations.Type;
import org.joda.time.DateTime;

import cz.sa.shiftPlanner.entities.infrastructure.AbstractVO;

@Entity
@Table(name="rule")
public class RuleVO extends AbstractVO {
	
	@ManyToOne(cascade = CascadeType.DETACH, fetch = FetchType.LAZY)
	private PersonVO person;
	
	@Column(nullable=false, columnDefinition="witch week in cycle it is (1-4)")
	private int week;
	
	@ManyToOne(cascade = CascadeType.DETACH, fetch = FetchType.LAZY)
	private BusTurnsTimetableVO turn;
	
	public BusTurnsTimetableVO getTurn() {
		return turn;
	}

	public void setTurn(BusTurnsTimetableVO turn) {
		this.turn = turn;
	}


	public PersonVO getPerson() {
		return person;
	}


	public void setPerson(PersonVO person) {
		this.person = person;
	}


	public int getWeek() {
		return week;
	}


	public void setWeek(int week) {
		this.week = week;
	}


	@Override
	public String toString() {
		return "RuleVO [week=" + week + "]";
	}

    
}
