package cz.sa.shiftPlanner.entities;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import cz.sa.shiftPlanner.entities.infrastructure.AbstractNoGenVO;

/**
 * @author ToSk
 */

@Entity
@Table(name="time_code")
public class TimeCodeVO extends AbstractNoGenVO{
	
	@Column
	private String description;
	
	@Column
	private Integer mark;
	
	@OneToMany(mappedBy = "timeCode", cascade=CascadeType.ALL)
	List<TimeCodeItemVO> items = new ArrayList<TimeCodeItemVO>();
	
	@OneToMany(mappedBy = "timeCode")
	List<BusTimetableVO> timetables = new ArrayList<BusTimetableVO>();

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}


	public Integer getMark() {
		return mark;
	}

	public void setMark(Integer mark) {
		this.mark = mark;
	}

	public List<TimeCodeItemVO> getItems() {
		return items;
	}

	public void setItems(List<TimeCodeItemVO> items) {
		this.items = items;
	}

	public List<BusTimetableVO> getTimetables() {
		return timetables;
	}

	public void setTimetables(List<BusTimetableVO> timetables) {
		this.timetables = timetables;
	}

	@Override
	public String toString() {
		return "TimeCodeVO ["+getId()+" description=" + description + ", mark=" + mark + "]";
	}
	
	
}


