package cz.sa.shiftPlanner.infrastructure.dao;

import java.util.Collection;

import org.hibernate.LockOptions;

import cz.sa.shiftPlanner.entities.infrastructure.AbstractVO;



/**
 * @author Tomas Skopal
 */

public abstract class AbstractDao extends HibernateSessionAccessor {

  protected void saveAll(Collection<? extends AbstractVO> vos) {
    for (AbstractVO abstractVO : vos) {
      getSession().save(abstractVO);
    }
  }
  
  protected void updateAll(Collection<? extends AbstractVO> vos) {
    for (AbstractVO abstractVO : vos) {
      getSession().update(abstractVO);
    }
  }

  protected void deleteAll(Collection<? extends AbstractVO> vos) {
    for (AbstractVO abstractVO : vos) {
      getSession().delete(abstractVO);
    }
  }

  protected void evictAll(Collection<? extends AbstractVO> vos) {
    for (AbstractVO abstractVO : vos) {
      getSession().evict(abstractVO);
    }
  }

  @SuppressWarnings("unchecked")
  protected <T extends AbstractVO> T get(Class<T> objectClass, Long id) {
    return (T) getSession().get(objectClass, id);
  }
  
  @SuppressWarnings("unchecked")
  protected <T extends AbstractVO> T lock(Class<T> objectClass, Long id) {
    return (T) getSession().get(objectClass, id, LockOptions.UPGRADE);
  }
}
