package cz.sa.shiftPlanner.services;

import java.util.List;
import java.util.Map;

import org.joda.time.DateTime;

import cz.sa.shiftPlanner.dto.BusTimetableDTO;
import cz.sa.shiftPlanner.dto.CityDTO;
import cz.sa.shiftPlanner.enums.WeekDay;
import cz.sa.shiftPlanner.utils.Tuple;

public interface BusTimetableService {

	void create(BusTimetableDTO timetable);

	void update(BusTimetableDTO timetable);

	void remove(BusTimetableDTO timetable);
	
	//void saveList(List<BusTimetableDTO> times);
	
	Map<Tuple<CityDTO, CityDTO>, List<BusTimetableDTO>> findByLineGroupId(Long id, DateTime validity);
	
	Map<Tuple<CityDTO, CityDTO>, List<BusTimetableDTO>> findByLineGroupIdAndDay(Long id, WeekDay day, DateTime validity);
	
	Map<Tuple<CityDTO, CityDTO>, List<BusTimetableDTO>> findByLineGroupIdAndDay(Long id, DateTime day, DateTime validity);
}
