package cz.sa.shiftPlanner.services;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.joda.time.DateTime;

import cz.sa.shiftPlanner.dto.BusConnectionDTO;
import cz.sa.shiftPlanner.dto.BusTimetableDTO;
import cz.sa.shiftPlanner.dto.BusTurnsTimetableDTO;
import cz.sa.shiftPlanner.dto.CityDTO;
import cz.sa.shiftPlanner.entities.BusTimetableVO;
import cz.sa.shiftPlanner.entities.BusTurnsTimetableVO;
import cz.sa.shiftPlanner.enums.WeekDay;
import cz.sa.shiftPlanner.utils.Tuple;

public interface BusTurnsTimetableService {


	void create(BusTurnsTimetableDTO timetable);

	void update(BusTurnsTimetableDTO timetable);

	void remove(BusTurnsTimetableDTO timetable);

	
	Map<Tuple<CityDTO, CityDTO>, List<BusTurnsTimetableDTO>> findByLineGroupId(Long id);
	
    List<List<BusTurnsTimetableDTO>> findByLineGroupIdAndDay(Long id, WeekDay days, Integer week, DateTime validity);
    
    BusTurnsTimetableDTO findByDayAndTimetable(BusTimetableDTO timetable, WeekDay day, Integer week);
    
    BusTurnsTimetableDTO findByDayAndTimetable(BusTimetableDTO timetable, WeekDay day, DateTime validity, Integer week);

    BusTurnsTimetableDTO findByConnection(BusConnectionDTO conn);
    
	void saveList(List<BusTurnsTimetableDTO> turns, DateTime validity, boolean manageBohtWeeks);

	void removeList(List<BusTurnsTimetableDTO> turns, boolean manageBohtWeeks);
}
