package cz.sa.shiftPlanner.services;

import java.util.List;

import org.joda.time.DateTime;
import org.springframework.security.access.annotation.Secured;

import cz.sa.shiftPlanner.dto.CityDTO;
import cz.sa.shiftPlanner.dto.PersonDTO;
import cz.sa.shiftPlanner.utils.PlannerRoles;

public interface PersonService {

  PersonDTO get(Long id);

  void remove(PersonDTO person);

  void downloadStewardsFromHelios();

  void createUsersInDTB();
  
//  @Secured({PlannerRoles.COORDINATOR, PlannerRoles.HELPLINKA})
  List<PersonDTO> findAll();

  List<PersonDTO> findByName(String name, String surname);

  List<PersonDTO> findByLineGroup(Long id);

  PersonDTO findByPersonalNumber(Long number);

  List<PersonDTO> findAllByTrialDay(DateTime day);

  List<PersonDTO> findByDepCity(CityDTO city);

  List<PersonDTO> findByHPP(String jobTime);

}
