package cz.sa.shiftPlanner.services;

import java.util.List;

import org.joda.time.DateTime;

import cz.sa.shiftPlanner.dto.BusConnectionDTO;
import cz.sa.shiftPlanner.dto.ExcuseDTO;
import cz.sa.shiftPlanner.dto.PersonDTO;
import cz.sa.shiftPlanner.dto.WayDTO;
import cz.sa.shiftPlanner.utils.ServiceNoticeException;

public interface WayService {

	WayDTO get(Long id);

	void create(WayDTO way) throws ServiceNoticeException;
	
	void createUseWayTime(WayDTO way) throws ServiceNoticeException;
	
	WayDTO create(BusConnectionDTO conn,  PersonDTO per, boolean isCheckIn, boolean isAdmin) throws ServiceNoticeException;
	
	void createAll(List<BusConnectionDTO> conn, PersonDTO per, boolean isCheckIn, boolean isAdmin) throws ServiceNoticeException;

	void update(WayDTO way);

	void remove(WayDTO way, boolean clearance);

	void remove(WayDTO way);
	
	List<WayDTO> findByTimeRange(DateTime from, DateTime to, PersonDTO p);
	
	List<WayDTO> findAll();
	
	List<List<WayDTO>> findByMonth(int month, PersonDTO p);

  void archive(WayDTO way, ExcuseDTO excuse);

}
