package cz.sa.shiftPlanner.servicesImpl;

import java.util.ArrayList;
import java.util.List;

import org.dozer.Mapper;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import cz.sa.shiftPlanner.dao.CityDAO;
import cz.sa.shiftPlanner.dto.CityDTO;
import cz.sa.shiftPlanner.dto.LineGroupDTO;
import cz.sa.shiftPlanner.dto.StationDTO;
import cz.sa.shiftPlanner.entities.CityVO;
import cz.sa.shiftPlanner.entities.LineGroupVO;
import cz.sa.shiftPlanner.entities.StationVO;
import cz.sa.shiftPlanner.services.CityService;

@Service
@Transactional(propagation = Propagation.REQUIRED)
public class CityServiceImpl implements CityService {

	private CityDAO cityDAO;
	private Mapper mapper;
	
	
	public void setMapper(Mapper mapper) {
		this.mapper = mapper;
	}

	public void setCityDAO(CityDAO cityDAO) {
		this.cityDAO = cityDAO;
	}

	@Override
	@Transactional(propagation = Propagation.REQUIRED, readOnly = true)
	public CityDTO get(Long id) {
		return null;
	}

	@Override
	@Transactional(propagation = Propagation.REQUIRED)
	public void create(CityDTO city) {
		
	}

	@Override
	@Transactional(propagation = Propagation.REQUIRED)
	public void update(CityDTO city) {
		
	}

	@Override
	@Transactional(propagation = Propagation.REQUIRED)
	public void remove(CityDTO city) {

		cityDAO.remove(cityDAO.get(city.getId()));
	}

	@Override
	@Transactional(propagation = Propagation.REQUIRED, readOnly = true)
	public List<CityDTO> findAll() {
		List<CityDTO> list = new ArrayList<CityDTO>();
		for(CityVO vo : cityDAO.findAll())
			list.add(mapper.map(vo, CityDTO.class));
		return list;
	}

	@Override
	@Transactional(propagation = Propagation.REQUIRED, readOnly = true)
	public List<CityDTO> findByName(String name) {
		List<CityDTO> list = new ArrayList<CityDTO>();
		for(CityVO vo : cityDAO.findByName(name))
			list.add(mapper.map(vo, CityDTO.class));
		return list;
	}

  @Override
  @Transactional(readOnly = true)
  public List<CityDTO> findAllCZ() {
    List<CityDTO> list = new ArrayList<CityDTO>();
    for(CityVO vo : cityDAO.findAllCZ())
      list.add(mapper.map(vo, CityDTO.class));
    return list;
  }

  @Override
  public List<StationDTO> findAllStations() {
    List<StationDTO> list = new ArrayList<StationDTO>();
    for(StationVO vo : cityDAO.findAllStations())
      list.add(mapper.map(vo, StationDTO.class));
    return list;
  }

}
