package cz.sa.shiftPlanner.utils;

import org.joda.time.DateTime;

/**
 * @author ToSk
 */

public class DateFormatter {

  /**
   * 
   * @param dt
   * @return dt in format: D.M H:m
   */
	public static String toDateAndTime(DateTime dt){
		String sTime;
		sTime = String.valueOf(dt.getDayOfMonth()+ "." + dt.getMonthOfYear());
		sTime += " "+ String.format("%02d",dt.getHourOfDay()) +":"+ String.format("%02d",dt.getMinuteOfHour());
		return sTime;
	}
	
	/**
   * 
   * @param dt
   * @return dt in format: D - d.name (shortcut) (30 - monday)
   */
	public static String dateFormatToDay(DateTime dt) {
    String sTime;
    sTime = dt.getDayOfMonth() + " - " + String.valueOf(dt.dayOfWeek().getAsShortText());
    return sTime;
  }
	
	public static String toCompletTimestamp(DateTime dt){
		String sTime;
		sTime = String.valueOf(dt.getDayOfMonth()+ "." + dt.getMonthOfYear()+ "." + dt.getYear());
		sTime += " "+ String.format("%02d",dt.getHourOfDay()) +":"+ String.format("%02d",dt.getMinuteOfHour());
		return sTime;
	}
	
	public static String dateFormatToTime(DateTime dt){
		String sTime;
		sTime= String.format("%02d",dt.getHourOfDay()) +" : "+ String.format("%02d",dt.getMinuteOfHour());
		return sTime;
	}
	
	/**
   * 
   * @param dt
   * @return dt in format: d.name (shortcut) - D.M (monday - 30.12)
   */
	public static String dateFormatToDate(DateTime dt) {
		String sTime;
		sTime = String.valueOf(dt.dayOfWeek().getAsText()) + " - " + dt.getDayOfMonth()
				+ "." + dt.getMonthOfYear();
		return sTime;
	}
	
	/**
   * 
   * @param dt
   * @return dt in format:  D.M (30.12)
   */
  public static String toDate(DateTime dt) {
    String sTime;
    sTime =  dt.getDayOfMonth() + "." + dt.getMonthOfYear();
    return sTime;
  }
  
  public static String toTime(DateTime time) {
    String sTime;
    sTime = String.format("%02d", time.getHourOfDay()) + " : " + String.format("%02d", time.getMinuteOfHour());
    return sTime;
  }
	
	public static DateTime toBeginOfDay(DateTime dt){
		return new DateTime(dt.getYear(), dt.getMonthOfYear(), dt.getDayOfMonth(), 0, 0, 0, 0);
	}
	
	public static DateTime toEndOfDay(DateTime dt){
		return new DateTime(dt.getYear(), dt.getMonthOfYear(), dt.getDayOfMonth(), 23, 59, 0, 0);
	}
	
	public static DateTime getBeginOfMonthThisYear(int month){
    DateTime dt = new DateTime();
    return new DateTime(dt.getYear(), month, 1, 0, 0, 0, 0);
  }
	
	public static DateTime getEndOfMonthThisYear(int month){
	  DateTime dt = new DateTime().withMonthOfYear(month);
	  return new DateTime(dt.getYear(), month, getDaysInMonth(dt), 0, 0, 0, 0);
	}
	
	public static Integer getWeekMod4(DateTime dt){
		return dt.getWeekOfWeekyear()%4 == 0 ? 4 : dt.getWeekOfWeekyear()%4;
	}
	
	public static Integer getWeekMod2(DateTime dt){
		if(dt == null)
			return 1;
		return dt.getWeekOfWeekyear()%2 == 0 ? 2 : dt.getWeekOfWeekyear()%2;
	}

  public static int getDaysInMonth(DateTime dt) {
    return new DateTime(dt.getYear(),dt.plusMonths(1).getMonthOfYear(),1,0,0,0,0).minusDays(1).getDayOfMonth();
  }
	
}


