package cz.sa.shiftPlanner.ybus.sync;

import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import cz.sa.shiftPlanner.dao.CityDAO;
import cz.sa.shiftPlanner.entities.CityVO;
import cz.sa.shiftPlanner.entities.StationVO;
import cz.sa.ybus.api.ObjectFactory;
import cz.sa.ybus.api.YCity;
import cz.sa.ybus.api.YStation;

/**
 * @author ToSk
 */

@Service
//@Transactional(propagation = Propagation.REQUIRES_NEW)
public class SyncCities extends SyncAction {

	private static final Logger log = Logger.getLogger(SyncCities.class);
	
	private void downloadCities() {
	  log.info("update cities start");
		List<YCity> citys = null;
		citys = getService().getCities("cs");

		if (citys == null)
			throw new NullPointerException("Cities is null");

		for (YCity yCity : citys) {
      CityVO newCity = new CityVO();
      newCity.setId(yCity.getId());
      newCity.setCityName(yCity.getName());
      newCity.setCountry(yCity.getCountryCode());
      if(cityDAO.get(yCity.getId()) == null){
        cityDAO.create(newCity);
      }else{
        cityDAO.update(newCity);
      }
    }
		
		log.info("update cities ends");
	}
	
	private void downloadStations(){
		log.info("update stations start");
		List<YStation> stations = null;
    stations = getService().listStations();
    
    if (stations == null)
      throw new NullPointerException("Stations is null");
    
    for (YStation yStation : stations) {
      StationVO newSt = new StationVO();
      newSt.setId(yStation.getId());
      newSt.setStationName(yStation.getName());
      CityVO city= cityDAO.get(yStation.getCityId());
      if(city != null)
        newSt.setCity(city);
      else
        throw new IllegalArgumentException("Can't find appropriate city");
      
      cityDAO.createStation(newSt);
      
    }
		log.info("update stations ends");
	}
	
	@Override
	public void run() {
//			downloadCities();
//			downloadStations();

		log.info("run cities");
	}

}


