package cz.sa.shiftPlanner.ybus.sync;

import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import cz.sa.shiftPlanner.dao.TimeCodeDAO;
import cz.sa.shiftPlanner.entities.TimeCodeItemVO;
import cz.sa.shiftPlanner.entities.TimeCodeVO;
import cz.sa.ybus.api.ObjectFactory;
import cz.sa.ybus.api.TimeCode;
import cz.sa.ybus.api.TimeCodeItem;

/**
 * @author ToSk
 */

@Service
//@Transactional(propagation = Propagation.REQUIRES_NEW)
public class SyncTimeCodes extends SyncAction {

  private static final Logger log = Logger.getLogger(SyncTimeCodes.class);
	
	private List<TimeCodeVO> getTimeCodes() {

		List<TimeCode> codes = getService().listTimeCodes();
		List<TimeCodeItem> items = getService().listTimeCodeItems();
		List<TimeCodeVO> result = new ArrayList<TimeCodeVO>();
		for(TimeCode t : codes){
			TimeCodeVO code = new TimeCodeVO();
			code.setDescription(t.getDescription());
			code.setId(t.getId());
			code.setMark(t.getMark());
			//pokusim se najit vsechny prislusne code_items
			List<TimeCodeItemVO> itemsLoc = new ArrayList<TimeCodeItemVO>();
			for(TimeCodeItem item : items){
				//pokud najdu shodu pridam item do listu v time_code 
				if(item.getTimeCodeId().equals(t.getId())){
					TimeCodeItemVO newItem = new TimeCodeItemVO();
					newItem.setId(item.getId());
					newItem.setFrom_(item.getDateFrom().toDateTimeAtCurrentTime());
					newItem.setTo_(item.getDateTo().toDateTimeAtCurrentTime());
					newItem.setType(item.getTimeCodeItemType().name());
					newItem.setTimeCode(code);
					itemsLoc.add(newItem);
				}
			}
			code.setItems(itemsLoc);
			result.add(code);
		}

		log.info("get timecode end");
		return result;
	}
	
	private void downloadTimeCodes(){
		for(TimeCodeVO code : getTimeCodes()){
			TimeCodeVO cLoc = timeCodeDAO.get(code.getId());
			if(cLoc == null){
				timeCodeDAO.save(code);
				log.info("TimeCode "+code.getId()+" was saved");
			}else{
				cLoc.setDescription(code.getDescription());
				cLoc.setItems(code.getItems());
				cLoc.setMark(code.getMark());
				timeCodeDAO.update(cLoc);
				log.info("TimeCode "+code.getId()+" was updated");
			}
		}
		log.info("download TimeCode end");
	}
	
	@Override
	public void run() {
//		downloadTimeCodes();
		log.info("run timecodes");
	}
}


