package cz.sa.shiftPlanner.application;

import java.util.Locale;

import org.apache.wicket.util.convert.converter.AbstractConverter;
import org.joda.time.DateTime;
import org.joda.time.ReadableInstant;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;
import org.springframework.util.StringUtils;


public class DateTimeConverter extends AbstractConverter<DateTime> {

  public static final DateTimeConverter INSTANCE = new DateTimeConverter();

  private DateTimeConverter() {
  }

  @Override
  protected Class<DateTime> getTargetType() {
    return DateTime.class;
  }

  public DateTime convertToObject(String value, Locale locale) {
    if (!StringUtils.hasText(value)) {
      return null;
    }

    try {
      return getFormatter(locale).parseDateTime(value);
    } catch (IllegalArgumentException e) {
      throw newConversionException(e.getMessage(), value, locale);
    }
  }

  @Override
  public String convertToString(DateTime value, Locale locale) {
    if (value == null) {
      return "";
    }

    return getFormatter(locale).print((ReadableInstant) value);
  }

  private DateTimeFormatter getFormatter(Locale locale) {
    return DateTimeFormat.shortDateTime().withLocale(locale);
  }

}
