package cz.sa.shiftPlanner.pcomponent;

import java.util.Arrays;
import java.util.List;
import java.util.Set;

import org.apache.wicket.markup.html.form.DropDownChoice;
import org.apache.wicket.markup.html.form.IChoiceRenderer;
import org.apache.wicket.model.IModel;

import com.google.common.collect.Lists;


public class EnumDropDownChoice<T extends Enum<?>>  extends DropDownChoice<T> implements IChoiceRenderer<T> {

  public EnumDropDownChoice(String id, Class<T> enumClass) {
    super(id, Arrays.asList(enumClass.getEnumConstants()));
    setChoiceRenderer(this);
  }

  public EnumDropDownChoice(String id, Class<T> enumClass, IModel<T> model) {
    super(id, model, Arrays.asList(enumClass.getEnumConstants()));
    setChoiceRenderer(this);
  }

  public EnumDropDownChoice(String id, T... enumItems) {
    super(id, Arrays.asList(enumItems));
    setChoiceRenderer(this);
  }
  
  public EnumDropDownChoice(String id, List<T> enumItems) {
    super(id, enumItems);
    setChoiceRenderer(this);
  }

  public EnumDropDownChoice(String id, List<T> enumItems, IModel<T> model) {
    super(id, model, enumItems);
    setChoiceRenderer(this);
  }
  
  public EnumDropDownChoice(String id, IModel<List<T>> enumItems, IModel<T> model) {
    super(id, model, enumItems);
    setChoiceRenderer(this);
  }

  public EnumDropDownChoice(String id, Set<T> validCurrencies) {
    this(id, Lists.newArrayList(validCurrencies));
  }

  public Object getDisplayValue(T object) {
    return EnumMessageSource.getEnumResourceString(object, getLocale());
  }

  public String getIdValue(T object, int index) {
    return Integer.toString(index);
  }

}