package cz.sa.shiftPlanner.pcomponent;

import java.util.Locale;

import org.springframework.context.support.ReloadableResourceBundleMessageSource;

/**
 * @author ToSk
 *
 */
public final class EnumMessageSource extends ReloadableResourceBundleMessageSource  {

  private static final PMessageSource ms = new PMessageSource(EnumMessageSource.class);

  private EnumMessageSource() {}

  public static String getEnumResourceString(Enum<?> enumValue, Locale locale) {
    String enumFullName = enumValue.getClass().getSimpleName() + '.' + enumValue.name();
    return ms.getMessage(locale, enumFullName);
  }

}
