package cz.sa.shiftPlanner.pcomponent;

import javax.annotation.Nullable;

import org.apache.wicket.Component;
import org.apache.wicket.feedback.FeedbackMessage;
import org.apache.wicket.feedback.IFeedbackMessageFilter;
import org.apache.wicket.markup.head.IHeaderResponse;
import org.apache.wicket.markup.head.OnLoadHeaderItem;
import org.apache.wicket.markup.html.panel.FeedbackPanel;


public abstract class PAbstractFeedbackPanel extends FeedbackPanel implements IFeedbackMessageFilter {
  
  /**
   * Pokud zadan, pak definuje zpusob, jak jednotlive zpravy vyrenderovat.
   * Pokud nezadan, jsou jednotlive zpravy vyrenderovany klasickym zpusobem.
   */
  @Nullable private final IFeedbackMesssageComponentCreator feedbackMesssageComponentCreator;

  public PAbstractFeedbackPanel(String id) {
    this(id, null);
  }
  
  public PAbstractFeedbackPanel(String id, @Nullable IFeedbackMesssageComponentCreator feedbackMesssageComponentCreator) {
    super(id);
    setFilter(this);
    setOutputMarkupId(true);
    this.feedbackMesssageComponentCreator = feedbackMesssageComponentCreator;
  }
  
  @Override
  protected Component newMessageDisplayComponent(String id, FeedbackMessage message) {
    if (feedbackMesssageComponentCreator != null) {
      return feedbackMesssageComponentCreator.newMessageDisplayComponent(id, message, this);
    }
    else {
      return super.newMessageDisplayComponent(id, message);
    }
  }
  
  
  /**
   * Timto js se docilime toho, ze prohlizec pri nacteni stranky "prejde" na
   * zadany prvek (dle id), takze ho na strance zobrazi urcite zobrazi. 
   * Muze se stat, ze uzivatel ma mensi okno a nezobrazi se mu cely dokument a feedback se zpravou
   * muze byt mimo viditelnou oblast okna. Timto zajistime, aby feedback panel, ktery ma zpravu byl
   * v okne vzdy zobrazen.
   */
  @Override
  public void renderHead(IHeaderResponse response) {   
    super.renderHead(response);
    if(this.anyMessage()) { 
      response.render(OnLoadHeaderItem.forScript("location.hash='" + this.getMarkupId()+ "'"));
    }
    
  }

}
