package cz.sa.shiftPlanner.pcomponent;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.extensions.ajax.markup.html.modal.ModalWindow;
import org.apache.wicket.extensions.ajax.markup.html.modal.ModalWindow.CloseButtonCallback;
import org.apache.wicket.extensions.ajax.markup.html.modal.ModalWindow.WindowClosedCallback;
import org.apache.wicket.markup.head.IHeaderResponse;
import org.apache.wicket.markup.head.JavaScriptHeaderItem;
import org.apache.wicket.model.IModel;
import org.apache.wicket.request.resource.JavaScriptResourceReference;


public class PlannerModalWindow extends ModalWindow implements WindowClosedCallback, CloseButtonCallback {

  private static final String JAVASCRIPT = "close.js";

  public PlannerModalWindow(String id, int width) {
    this(id);
    setInitialWidth(width);
    setUseInitialHeight(false);
    setResizable(false);
  }

  public PlannerModalWindow(String id, int width, int height) {
    this(id);
    setInitialWidth(width);
    setInitialHeight(height);
  }

  private PlannerModalWindow(String id) {
    super(id);
    setWindowClosedCallback(this);
    setCloseButtonCallback(this);
    setResizable(false);
  }
  
  @Override
  public void renderHead(IHeaderResponse response) {
    super.renderHead(response);
    response.render(JavaScriptHeaderItem.forReference(new JavaScriptResourceReference(PlannerModalWindow.class, JAVASCRIPT)));
  }

  @Override
  public ModalWindow setTitle(IModel<String> title) {
    return super.setTitle(wrap(title));
  }

  @Override
  public final void close(AjaxRequestTarget target) {
    onBeforeClose(target);
    super.close(target);
    getContent().setVisible(false);
  }

  public final boolean onCloseButtonClicked(AjaxRequestTarget target) {
    onBeforeClose(target);
    getContent().setVisible(false);
    onAfterCloseButtonClicked(target);
    return true;
  }

  public final void onClose(AjaxRequestTarget target) {
    ((WindowSupportingPage) getPage()).returnWindowId(getId());
    onAfterClose(target);
  }

  protected void onBeforeClose(AjaxRequestTarget target) {
  }

  protected void onAfterClose(AjaxRequestTarget target) {
  }
  
  protected void onAfterCloseButtonClicked(AjaxRequestTarget target) {
  }

}
