package cz.sa.shiftPlanner.web.auth;

import org.apache.log4j.Logger;
import org.apache.wicket.Component;
import org.apache.wicket.ajax.AbstractDefaultAjaxBehavior;
import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.markup.head.IHeaderResponse;
import org.apache.wicket.markup.head.OnDomReadyHeaderItem;

/**
 * @author ToSk
 */

/**
 * Since the session is managed on the server side, you have to send an AJAX
 * request to the server when the user leaves the page. The following Behavior
 * implementation does just that.
 */
public class PageExitLogoutBehavior extends AbstractDefaultAjaxBehavior {

	private final Logger log = Logger.getLogger(PageExitLogoutBehavior.class);

	@Override
	public void renderHead(Component component, IHeaderResponse response) {
		super.renderHead(component, response);
		response.render(new OnDomReadyHeaderItem(String.format(
				"window.onbeforeunload = function(e){ %s };", this.getCallbackScript())));
	}

	@Override
	protected void respond(AjaxRequestTarget target) {
		log.info("logging out throuhg PageExitLogoutBehavior");
		target.getPage().getSession().invalidate();
	}

}
