package cz.sa.shiftPlanner.web.notification;

import java.util.ArrayList;
import java.util.List;

import org.apache.wicket.AttributeModifier;
import org.apache.wicket.extensions.markup.html.repeater.data.grid.ICellPopulator;
import org.apache.wicket.extensions.markup.html.repeater.data.table.AbstractColumn;
import org.apache.wicket.extensions.markup.html.repeater.data.table.DataTable;
import org.apache.wicket.extensions.markup.html.repeater.data.table.DefaultDataTable;
import org.apache.wicket.extensions.markup.html.repeater.data.table.IColumn;
import org.apache.wicket.extensions.markup.html.repeater.data.table.PropertyColumn;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.markup.repeater.Item;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.Model;
import org.apache.wicket.spring.injection.annot.SpringBean;
import org.joda.time.DateTime;

import cz.sa.shiftPlanner.dto.BusConnectionDTO;
import cz.sa.shiftPlanner.dto.LineGroupDTO;
import cz.sa.shiftPlanner.pcomponent.LineGroupProvider;
import cz.sa.shiftPlanner.services.BusConnectionService;
import cz.sa.shiftPlanner.services.LineGroupService;
import cz.sa.shiftPlanner.utils.DateFormatter;

/**
 * 
 * @author ToSk
 * @version 1.0
 * @created 14. 10. 2013
 */

public class EmptyWayPanel extends Panel {

  @SpringBean(name = "lineGroupService")
  LineGroupService lineService;

  @SpringBean(name = "busConnectionService")
  BusConnectionService busConnectionService;

  private LineGroupProvider provider;

  public EmptyWayPanel(String id) {
    super(id);

    provider = new LineGroupProvider(lineService);
    DataTable dataTable = new DefaultDataTable<LineGroupDTO, String>("dataTable", columns(), provider, 30);
    add(dataTable);
  }

  private List<? extends IColumn<LineGroupDTO, String>> columns() {
    List<IColumn<LineGroupDTO, String>> columns = new ArrayList<IColumn<LineGroupDTO, String>>();
    columns.add(new PropertyColumn<LineGroupDTO, String>(new Model<String>("Jmeno"), "name"));
    columns.add(new AbstractColumn<LineGroupDTO, String>(new Model<String>("1. volny spoj")) {
      @Override
      public void populateItem(Item<ICellPopulator<LineGroupDTO>> cellItem, String componentId, IModel<LineGroupDTO> rowModel) {
        BusConnectionDTO conn = busConnectionService.findFirstEmpty(rowModel.getObject());
        if (conn != null) {
          cellItem.add(new Label(componentId, DateFormatter.toDateAndTime(conn.getDepartureTime()) + " "
              + conn.getTimetable().getDepartureStation().getCity().getCityName() + " -> "
              + conn.getTimetable().getArrivalStation().getCity().getCityName()));
        }
        else {
          cellItem.add(new Label(componentId, ""));
        }
        if (conn != null && conn.getDepartureTime().compareTo(new DateTime().plusHours(3)) < 0)
          cellItem.add(new AttributeModifier("style", "color: red"));
      }
    });
    return columns;
  }

}
