package cz.sa.shiftPlanner.web.notification;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.markup.html.AjaxLink;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.image.Image;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.IModel;
import org.apache.wicket.request.resource.ContextRelativeResource;
import org.apache.wicket.spring.injection.annot.SpringBean;

import cz.sa.shiftPlanner.dto.NotificationDTO;
import cz.sa.shiftPlanner.services.NotificationService;
import cz.sa.shiftPlanner.web.auth.PlannerSession;

/**
 *
 * @author    ToSk
 * @version   1.0
 * @created   7. 10. 2013
 */

public class NotificationImagePanel extends Panel {

  @SpringBean(name = "notificationService")
  NotificationService notificationService;
  
  public NotificationImagePanel(String id, final IModel<NotificationDTO> model, final Form form) {
    super(id, model);

    AjaxLink read = new AjaxLink("read") {
      @Override
      public void onClick(AjaxRequestTarget target) {
        model.getObject().setReaded(!model.getObject().isReaded());
        notificationService.update(model.getObject());
        target.add(form);
      }
    };
    Image image;
    if (model.getObject().isReaded())
      image = new Image("image", new ContextRelativeResource("Images/mail_check.png"));
    else
      image = new Image("image", new ContextRelativeResource("Images/mail_new.png"));
    read.add(image);
    add(read);
  }

}
