package cz.sa.shiftPlanner.web.notification;

import org.apache.wicket.AttributeModifier;
import org.apache.wicket.Component;
import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.markup.html.form.AjaxButton;
import org.apache.wicket.extensions.ajax.markup.html.modal.ModalWindow;
import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.link.BookmarkablePageLink;
import org.apache.wicket.markup.html.list.AbstractItem;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.markup.repeater.Item;
import org.apache.wicket.markup.repeater.data.DataView;
import org.apache.wicket.markup.repeater.data.ListDataProvider;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import org.apache.wicket.spring.injection.annot.SpringBean;

import cz.sa.shiftPlanner.dto.PersonDTO;
import cz.sa.shiftPlanner.entities.infrastructure.UserDTO;
import cz.sa.shiftPlanner.services.UserService;
import cz.sa.shiftPlanner.web.PersonDetailPage;

/**
 * @author ToSk
 */

public class WhoIsOnlinePanel extends Panel{
	
	@SpringBean(name = "userService")
    private UserService userService;
	
	public WhoIsOnlinePanel(String id){
		super(id);
		
		Component header = new AbstractItem("header");
		add(header);
		ListDataProvider<UserDTO> dp = new ListDataProvider<UserDTO>(userService.findSingIn());
		
		//TODO nahradit za DataTable jako je to v YBUSU v LineGroupsPage
        final DataView<UserDTO> dataView = new DataView<UserDTO>("repeating", dp)
        {
            private static final long serialVersionUID = 1L;

            @Override
            protected void populateItem(final Item<UserDTO> item)
            {
            	item.add(new Label("personalNumber", String.valueOf(item.getModelObject().getUsername())));
    			item.add(new Label("firstname", String.valueOf(item.getModelObject().getPerson().getName())));
    			item.add(new Label("surname", String.valueOf(item.getModelObject().getPerson().getSurname())));

                item.add(new AttributeModifier("class", (item.getIndex() % 2 == 1) ? "even" : "odd"));
            }
        };
        add(dataView);
	}
}


