package cz.sa.shiftPlanner.web.panels;

import java.util.Date;

import org.apache.wicket.datetime.StyleDateConverter;
import org.apache.wicket.datetime.markup.html.form.DateTextField;
import org.apache.wicket.extensions.yui.calendar.DatePicker;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.panel.FeedbackPanel;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.IModel;

public class CalendarPanel extends PAbstractPanel{

	private IModel<Date> dateModel;
	
	public CalendarPanel(String id, IModel<Date> dateModel) {
		super(id);
		
		this.dateModel = dateModel;
		createCalendar();
	}
	
	
	private void createCalendar(){        
		
		DateTextField dateTextField = new DateTextField("dateTextField", dateModel, new StyleDateConverter(false));
		Form<?> form = new Form<Void>("form"){
			@Override
			protected void onSubmit(){
				info("set date to " + dateModel.getObject());
			}
		};
	    
		add(form);
		form.add(dateTextField);
		
		DatePicker datePicker = new DatePicker()
		{
			@Override
			protected String getAdditionalJavaScript()
			{
				return "${calendar}.cfg.setProperty(\"navigator\",true,false); ${calendar}.render();";
			}
		};
		datePicker.setShowOnFieldClick(true);
		datePicker.setAutoHide(true);
		dateTextField.add(datePicker);
		
		//add(new FeedbackPanel("feedback"));
	}
	
}
