package cz.sa.shiftPlanner.web.panels;

import org.apache.wicket.Component;
import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.extensions.ajax.markup.html.modal.ModalWindow;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.spring.injection.annot.SpringBean;

import cz.sa.shiftPlanner.pcomponent.PlannerModalWindow;
import cz.sa.shiftPlanner.services.BusConnectionService;
import cz.sa.shiftPlanner.services.BusTurnsTimetableService;
import cz.sa.shiftPlanner.services.CityService;
import cz.sa.shiftPlanner.services.PersonService;
import cz.sa.shiftPlanner.services.WayService;

/**
 *
 * @author    ToSk
 * @version   1.0
 * @created   23. 9. 2013
 */

public class PlannerPanel extends Panel {

  @SpringBean(name = "busConnectionService")
  BusConnectionService busConnectionService;

  @SpringBean(name = "wayService")
  WayService wayService;

  @SpringBean(name = "busTurnsTimetableService")
  BusTurnsTimetableService busTurnsTimetableService;
  
  @SpringBean(name = "personService")
  PersonService personService;
  
  @SpringBean(name = "cityService")
  CityService cityService;
  
  private static final long serialVersionUID = 3282909183735L;

  public PlannerPanel(String id) {
    super(id);
  }

  protected void showWindow(AjaxRequestTarget target, ModalWindow modalWindow) {
    replace(modalWindow);
    target.appendJavaScript("Wicket.Window.unloadConfirmation = false;");
    modalWindow.show(target);
  }
  
  protected void closeWindow(AjaxRequestTarget target, Component component) {
    ((PlannerModalWindow) component.findParent(PlannerModalWindow.class)).close(target);
  }

}
