package cz.sa.shiftPlanner.web.wizard;

import org.apache.wicket.markup.head.CssHeaderItem;
import org.apache.wicket.markup.head.IHeaderResponse;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import org.apache.wicket.request.resource.CssResourceReference;

import cz.sa.shiftPlanner.web.MenuPage;

public class WizardPage extends MenuPage {

	public WizardPage(PageParameters parameters){
        super(parameters);
		
        switch(parameters.get("page").toInt()){
	        case 1:
	        	add(new TimetableTurnsWizard("wizardPage", parameters));
	        	break;
	        case 2:
	        	add(new RulesWizard("wizardPage", parameters));
	        	break;
	        case 3:
	        	add(new WayWizard("wizardPage", parameters));
	        	break;
        }
	}
	
	@Override
  public void renderHead(IHeaderResponse response) {   
    super.renderHead(response);
    
    response.render(CssHeaderItem.forReference(new CssResourceReference(WizardPage.class, "wizardComponent.css")));
  }
}
